{%- from "ceph/map.jinja" import osd, common with context %}

{%- set devs = [] %}
{%- set dbs = [] %}
{%- set wals = [] %}
{%- for backend_name, backend in osd.backend.iteritems() %}
{%- for disk in backend.disks %}
{%- set dev = disk.dev %}

{%- if disk.block_db is defined %}
{%- set db = disk.block_db %}
{%- do dbs.append(db) %}
{%- endif %}
{%- if disk.block_wal is defined %}
{%- set wal = disk.block_wal %}
{%- do wals.append(wal) %}
{%- endif %}
{%- do devs.append(dev) %}
{%- endfor %}
{%- endfor %}
{%- set end_size = {} %}
{%- set counter = {} %}

{%- if dbs != [] %}
{%- for db in dbs | unique %}
{%- do end_size.update({db: 1048576}) %}
{%- do counter.update({db: 1}) %}
create_disk_label_{{ db }}:
  module.run:
  - name: partition.mklabel
  - device: {{ db }}
  - label_type: gpt
  - unless: "fdisk -l {{ db }} | grep -i 'Disklabel type: gpt'"
{%- endfor %}
{%- for db in dbs %}
create_partition_{{ db }}_{{ counter[db] }}:
  module.run:
  - name: partition.mkpart
  - device: {{ db }}
  - part_type: primary
  - start: {{ end_size[db] }}B
  - end: {{ end_size[db] + osd.bluestore_block_db_size }}B
  - size: {{ osd.bluestore_block_db_size }}B
  - unless: "blkid {{ db }}{{ counter[db] }} {{ db }}p{{ counter[db] }}"
  - require:
    - module: create_disk_label_{{ db }}

{%- do counter.update({db: counter[db] + 1}) %}
{%- do end_size.update({db: end_size[db] + osd.bluestore_block_db_size + 1048576}) %}
{%- endfor %}
{%- endif %}

{%- if wals != [] %}
{%- for wal in wals | unique %}
{%- do end_size.update({wal: 1048576}) %}
{%- do counter.update({wal: 1}) %}
create_disk_label_{{ wal }}:
  module.run:
  - name: partition.mklabel
  - device: {{ wal }}
  - label_type: gpt
  - unless: "fdisk -l {{ wal }} | grep -i 'Disklabel type: gpt'"
{%- endfor %}
{%- for wal in wals %}
create_partition_{{ wal }}_{{ counter[wal] }}:
  module.run:
  - name: partition.mkpart
  - device: {{ wal }}
  - part_type: primary
  - start: {{ end_size[wal] }}B
  - end: {{ end_size[wal] + osd.bluestore_block_db_size }}B
  - size: {{ osd.bluestore_block_wal_size }}B
  - unless: "blkid {{ wal }}{{ counter[wal] }} {{ wal }}p{{ counter[wal] }}"
  - require:
    - module: create_disk_label_{{ wal }}

{%- do counter.update({wal: counter[wal] + 1}) %}
{%- do end_size.update({wal: end_size[wal] + osd.bluestore_block_wal_size + 1048576}) %}
{%- endfor %}
{% endif %}
